/*
 * Advanet Advme8001
 * VME Access Module
 * H.baba
 * last modified : 03/06/24 18:09:46 
 */

#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/version.h>
#include <linux/ioctl.h>
#include <linux/sched.h>
#include <linux/config.h>
#include <linux/pci.h>
#include <linux/errno.h>
#include <asm/io.h>

#include "advme.c"

#if LINUX_VERSION_CODE >=  0x020410
  MODULE_LICENSE("GPL");
#endif

int detect_pci_device(unsigned vendor,unsigned device,unsigned long *tioa,
		      unsigned long *tiob, unsigned long *tir);

static int girq;

int init_module(void){
    int ret;
    unsigned long tioa,tiob,tir;

    ret = detect_pci_device(ADVME_VENDOR_ID,ADVME_DEVICE_ID,&tioa,&tiob,&tir);
    if(ret){
      printk("ADVME Can't find.\n");
      return ret;
    }
    printk("ADVME found at 0x%04lx 0x%04lx on irq %lu.\n",tioa,tiob,tir);

    if(advme_init_register(tir,tioa) == -1){
      return -ENODEV;
    }

    girq = tir;

    return 0;
}

void cleanup_module(void){
  vfree(vreg->lcr);
}

int detect_pci_device(unsigned vendor,unsigned device,unsigned long *tioa,
		      unsigned long *tiob, unsigned long *tir){
    struct pci_dev *dev;

    if (!pcibios_present()){
      printk("ADVME: unable to find PCI bios.\n");
      return -ENODEV;
    }

    dev = NULL;
    dev = pci_find_device(vendor, device, dev);

    if(dev == NULL){
      return -ENODEV;
    }

#if LINUX_VERSION_CODE >=  0x020400
    *tioa = dev->resource[0].start & PCI_BASE_ADDRESS_IO_MASK;
    *tiob = dev->resource[1].start & PCI_BASE_ADDRESS_IO_MASK;
    *tir  = dev->irq;
#else
    *tioa = dev->base_address[0] & PCI_BASE_ADDRESS_IO_MASK;
    *tiob = dev->base_address[1] & PCI_BASE_ADDRESS_IO_MASK;
    *tir  = dev->irq;
#endif

    return 0;
}

int advme_get_irq(void){
  return girq;
}
